// Nanako.c

#pragma output STACKPTR=32767

// Includes:
#include <spritepack.h>
#include "externs.h"			// Mira: esto permite definir aqu externs y poner los datos en plan guarro al final
								// Esto mola sobre todo porque as paginar es mucho ms fcil (e divertente).
#include "aplib.h"				// Depacker

/*	Direcciones de las pantallas comprimidas
	========================================

	Apuntado queda todo aqu, que luego se me va el pinrel.

	RAM3:
	
	Qu 			Dnde		Cunto
	mojon_twins 	49152		361
	ubhres			49513		1203
	comic_1 		50716		1204
	comic_2 		51920		1967
	comic_3 		53887		2061
	men			55948		3539
	marco			59487		2392
	final			61879		2051
	game_over		63930		1043
	----------------------------------
	ram3			49152		15821
	
*/
																
// Defines:

#define AD_FREE 		60000	// 58000

#define S_MOJON_TWINS	49152
#define S_UBHRES		49513
#define S_COMIC_1		50716
#define S_COMIC_2		51920
#define S_COMIC_3		53887
#define S_MENU			55948
#define S_MARCO 		59487
#define S_FINAL 		61879
#define S_GAME_OVER 	63930

// Mirar la tabla de smbolos del wyzplayer.asm al ensamblar por si cambia algo:

#define INICIAEFECTO	0xC364
#define WYZPLAYERISR	0xC021	// Esto es INICIO en el cdigo de wyzplayer.asm
#define CARGA_CANCION	0xC05E	// 0xC063
#define SILENCIA_PLAYER 0xC043	// 0xC048

// Estados:

#define STATE_IDLE		0
#define STATE_WLEFT 	1
#define STATE_WRIGHT	2
#define STATE_WUP		3
#define STATE_WDOWN 	4
#define STATE_DEAD		5
#define STATE_APARECE	6

#define FACING_LEFT 	0
#define FACING_RIGHT	1
#define FACING_UP		2
#define FACING_DOWN 	3

#define NUM_PERSISTENCIAS	15

// Struct/types:

extern struct sp_Rect *sp_ClipStruct;
extern char asm_number[1];
extern char *Rand8;
struct sp_Rect spritesClipValues;
struct sp_Rect *spritesClip;
struct sp_UDK keys;
void *joyfunc;				// Puntero a la funcin de manejo seleccionada.
extern unsigned int asm_int_2[1];
unsigned char menzae [] = " 						 WHOAH! NANAKO PUTS THE FOUR ARTIFACTS TOGETHER AND A WEAPON OF INCREDIBLE POWER UNVEILS! TIME TO GO BACK TO HER TOWN AND SLAY A FEW MONSTERS! SEE YOU PLAYING BINIAX, MAYBE... SALUDOS A VAH-KA. SEE YOU IN BINIAX 2!								\xff";
struct sp_PSS ps;			// a print string struct used by sp_PrintString
unsigned char kempston_is_attached;

//Structs para sprites, enemigos, etctera...

typedef struct {
	unsigned char state;	// 0 idle, 1 left, 2 right, 3 up, 4 down;
	unsigned char x, y, ct;
	unsigned char cx, cy;
	char lives, score;
	unsigned char o1, o2, o3, o4;
	unsigned char frame;
	unsigned char paso;
	unsigned char facing;
	unsigned char colliding;
} PERZONAE;

typedef struct {
	unsigned char pant;
	unsigned char x, y;
} PERSISTENCIA;

// Definimos los perzonae del juego.

PERZONAE nanako;
PERZONAE bisho;

// Definimos la tabla de persistencias

PERSISTENCIA persistencias [NUM_PERSISTENCIAS];

unsigned char map_buffer [49];
unsigned char map_buffer_r [49];

// Extern data:

#asm
	LIB SPCClipStruct
._sp_ClipStruct
	defw SPCClipStruct
._asm_number 
	defb 0
._asm_int_2
	defw 0
#endasm

// Globals:

char play = 0;
unsigned char is128k;
unsigned int asm_int;
unsigned char halflife = 0;
unsigned char tiene_bisho;
unsigned char *allpurposepuntero;
unsigned char aftergame = 0;
unsigned char buffer_nanako [18];
unsigned char buffer_bisho [18];
unsigned char joykeyboard = 0;		// Keyboard == 0; Joystick == 1;

struct sp_Rect rectangulo;

// Comportamiento de cada tile:
// 0 nada
// 1 solido
char behaviour [] = {
	0, 0, 2, 2, 1, 1, 1, 1, 1, 2,
	2, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1
};

// Objetos:
// 0 nada
// 1 agua bendita
// 2 cortafro (XD)
// 3 jacha
// 4 tesoro
// 5 slot vaco

char objetos [] = {
	0, 0, 0, 0, 2, 4, 3, 0, 0, 0,
	3, 5, 0, 0, 0, 0, 0, 2, 3, 0,
	2, 0, 0, 4, 2, 3, 0, 0, 4, 3,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
	1, 0, 0, 0, 0, 0, 0, 0, 1, 0,
	0, 4, 0, 0, 0, 0, 0, 0, 0, 3,
	1, 0, 0, 0, 0, 0, 0, 0, 0, 1,
	0, 3, 0, 0, 0, 0, 0, 2, 0, 2,
	0, 0, 0, 0, 2, 0, 0, 0, 1, 0,
	1, 1, 0, 0, 0, 0, 0, 0, 1, 2
};

char objetos_g [100];

char objetos_t [] = {0, 44, 45, 46, 43, 48};

void SetRAMBank() {
	#asm
		.SetRAMBank
			ld	A, ($5B5C)
			and F8h
			or	B
			ld	BC, $7FFD
			ld	($5B5C), A
			out (C), A	
	#endasm
}

/* MusicISR */
#asm
defw 0	// 2 bytes libres
#endasm

void ISR(void) {
	if (is128k) {
		#asm
			ld b, 1
			call SetRAMBank
			call WYZPLAYERISR
			ld b, 0
			call SetRAMBank 		
		#endasm
	}
}

void unpack_RAM3 (unsigned int address) {
	asm_int_2 [0] = address;
	
	#asm	
		di
		ld b, 3
		call SetRAMBank
		
		ld hl, (_asm_int_2)
		ld de, 16384
		call depack
		
		ld b, 0
		call SetRAMBank
		ei
	#endasm
}

void *my_malloc(unsigned int bytes) {
   return sp_BlockAlloc(0);
}

void *u_malloc = my_malloc;

void *u_free = sp_FreeBlock;

void wyz_play_sound (unsigned char fx_number, unsigned char fx_channel) {
	if (!is128k)
		return;
	
	asm_int_2 [0] = fx_channel + (fx_number * 256);
	
	#asm
		di
		ld b,1
		call SetRAMBank
		ld bc, (_asm_int_2)
		call INICIAEFECTO
		ld b,0
		call SetRAMBank
		ei
	#endasm
}

void wyz_play_music (unsigned char song_number) {
	if (!is128k)
		return;
	
	asm_int_2 [0] = song_number;

	#asm
		di
		ld b, 1
		call SetRAMBank
		ld a, (_asm_int_2)
		call CARGA_CANCION
		ld b, 0
		call SetRAMBank
		ei
	#endasm
}

void wyz_stop_sound ()
{
	if (!is128k)
		return;
	
	#asm
		di
		ld b,1
		call SetRAMBank
		call SILENCIA_PLAYER
		ld b,0
		call SetRAMBank
		ei
	#endasm
}

void ejcrol_asm_container () {
	#asm
		.escrolleft
						 
		;; calculamos hl
		
		ld	 a, (_asm_int) ; nos traemos el numero de linea
		ld	 l,a		   ; lo guardamos para no tener que pillarlo otra vez
		add  a, $40 	   ;
		and  $58		   ; nos quedamos con el tercio + $40
		ld	 h, a
		
		ld	 a, l		   ; recuperamos el numero de linea
		and  7			   ; linea dentro del tercio: linea MOD 8
		rrca
		rrca
		rrca			   ; rotamos pa la derecha del byte
		ld	 l, a	
		
		;;
		
		ld	 a, 8		   ; ocho lineas...
	.buclebmp1
		push af
		
		ld	 d,h
		ld	 e,l
		push bc
		push hl
		ld	 a,(hl)
		inc  hl
		ld	 bc, 31
		ldir
		dec  hl
		ld	 (hl),a
		pop  hl
		pop  bc
		
		pop  af
		inc  h
		dec  a
		jr	 nz, buclebmp1
		
		ret
		
	.vamonor
	#endasm 	
}

void fade_out () { 
	/* El segundo programa de ms de 5 lineas en Z80 ASM de na_th_an */ 
	/* Optimizado por Metalbrain */ 
	/* Esto "oscurece" un paso la pantalla. Llamado 8 veces la dejar en negro */ 
	unsigned char i;
	
	for (i = 0; i < 8; i ++) {	
		#asm 
			ld	 e, 3				; 3 tercios 
			ld	 hl, 22528			; aqu empiezan los atributos 
			halt					; esperamos retrazo. 
		.fade_out_bucle  
			ld	 a, (hl )			; nos traemos el atributo actual 
			
			ld	 d, a				; tomar atributo 
			and  7					; aislar la tinta 
			jr	 z, ink_done		; si vale 0, no se decrementa 
			dec  a					; decrementamos tinta 
		.ink_done 
			ld	 b, a				; en b tenemos ahora la tinta ya procesada. 
			
			ld	 a, d				; tomar atributo 
			and  56 				; aislar el papel, sin modificar su posición en el byte 
			jr	 z, paper_done		; si vale 0, no se decrementa 
			sub  8					; decrementamos papel restando 8 
		.paper_done 
			ld	 c, a				; en c tenemos ahora el papel ya procesado. 
			ld	 a, d  
			and  192				; nos quedamos con bits 6 y 7 (BRIGHT y FLASH) 
			or	 c					; aadimos paper 
			or	 b					; e ink, con lo que recompuesto el atributo 
			ld	 (hl),a 			; lo escribimos, 
			inc  l					; e incrementamos el puntero. 
			jr	 nz, fade_out_bucle ; continuamos hasta acabar el tercio (cuando L valga 0) 
			inc  h					; siguiente tercio 
			dec  e 
			jr	 nz, fade_out_bucle ; repetir las 3 veces 
		#endasm 
	}
}

void fade_in () { 
	// Otia, qu cutre de cojones, pero me sirve pa lo que quiero.
	// (Ley del Mnimo Esfuerzo, captulo 2, seccin 72, prrafo 4).
	
	unsigned char i;
	
	for (i = 0; i < 7; i ++) {	
		#asm 
			ld	 e, 3				; 3 tercios 
			ld	 hl, 22528			; aqu empiezan los atributos 
			halt					; esperamos retrazo. 
		.fade_in_bucle	
			ld	 a, (hl )			; nos traemos el atributo actual 
			
			ld	 d, a				; tomar atributo 
			and  7 
			inc  a					; decrementamos tinta 
		
			ld	 b, a				; en b tenemos ahora la tinta ya procesada. 
			
			ld	 a, d				; tomar atributo 
			and  56 				; aislar el papel, sin modificar su posición en el byte 
		
			ld	 c, a				; en c tenemos ahora el papel ya procesado. 
			ld	 a, d  
			and  192				; nos quedamos con bits 6 y 7 (BRIGHT y FLASH) 
			or	 c					; aadimos paper 
			or	 b					; e ink, con lo que recompuesto el atributo 
			ld	 (hl),a 			; lo escribimos, 
			inc  l					; e incrementamos el puntero. 
			jr	 nz, fade_in_bucle ; continuamos hasta acabar el tercio (cuando L valga 0) 
			inc  h					; siguiente tercio 
			dec  e 
			jr	 nz, fade_in_bucle ; repetir las 3 veces 
		#endasm 
	}
}

unsigned char rand () {
	unsigned char res;
	
	#asm
	
	; modo brutito: ON
	
			ld a,r
	._Rand8 ;ld a,9 	; Seed is usually 0
			;ld b,a
			;add	a,a
			;add	a,a
			;add	a,b
			;inc	a		; another possibility is ADD A,7
			;ld (_Rand8+1),a
			ld (_asm_number), a
	#endasm

	res = asm_number [0];

	return res;
}

void blackout_everything () {
	unsigned char *origin;

	origin = (unsigned char *) 22528;
	while (origin < 23296) {
		*origin = 0;
		origin ++;
	}
}

void mueve () {
	unsigned char i;
	unsigned char xx, yy;
	unsigned char mapidx;
	
	nanako.colliding = 0;

	if (nanako.state == STATE_IDLE) {
		xx = nanako.x / 3; yy = nanako.y / 3;
		mapidx = 7 * yy + xx;
		nanako.ct = 0;
			
		i = (joyfunc) (&keys);
		
		if ((i & sp_LEFT) == 0) {
			nanako.facing = FACING_LEFT;
			if (map_buffer [mapidx - 1] == 0 && nanako.x > 0) {
				nanako.state = STATE_WLEFT;
				nanako.frame = 53;
			} else
				nanako.colliding = map_buffer_r [mapidx - 1];
		}
				
		if ((i & sp_RIGHT) == 0) {
			nanako.facing = FACING_RIGHT;
			if (map_buffer [mapidx + 1] == 0 && nanako.x < 18) {
				nanako.state = STATE_WRIGHT;
				nanako.frame = 51;
			} else
				nanako.colliding = map_buffer_r [mapidx + 1];
		}
				
		if ((i & sp_UP) == 0) {
			nanako.facing = FACING_UP;
			if (map_buffer [mapidx - 7] == 0 && nanako.y > 0) {
				nanako.state = STATE_WUP;
				nanako.frame = 57;
			} else
				nanako.colliding = map_buffer_r [mapidx - 7];
		}
				
		if ((i & sp_DOWN) == 0) {
			nanako.facing = FACING_DOWN;
			if (map_buffer [mapidx + 7] == 0 && nanako.y < 18) {
				nanako.state = STATE_WDOWN;
				nanako.frame = 55;
			} else
				nanako.colliding = map_buffer_r [mapidx + 7];
		}
			
		if (nanako.state == STATE_IDLE) 
			nanako.paso = 0;
	} else {
		// Retardo YUJU!! (esto ir bajndolo a medida que vaya poniendo mierda)
		#asm
			halt
			halt
		#endasm 
		
		
		switch (nanako.state) {
			case STATE_WLEFT:
				nanako.x --;
				break;
			case STATE_WRIGHT:
				nanako.x ++;
				break;
			case STATE_WUP:
				nanako.y --;
				break;
			case STATE_WDOWN:	
				nanako.y ++;
				break;
		}
		
		nanako.ct ++;
		if (nanako.ct == 3)
			nanako.state = STATE_IDLE;
			
		nanako.paso = !nanako.paso;
	}
}

void mueve_bicharracos () {
	unsigned char i;
	unsigned char xx, yy;
	unsigned char mapidx;
	
	if (tiene_bisho) {
		if (bisho.state == STATE_IDLE) {
			xx = bisho.x / 3; yy = bisho.y / 3;
			mapidx = 7 * yy + xx;
			bisho.ct = 0;
			
			i = rand () % 15;
			
			switch (i) {
				case 1:
					if (map_buffer [mapidx - 1] == 0 && bisho.x > 0) {
						bisho.state = STATE_WLEFT;
					}
					break;
				case 2:
					if (map_buffer [mapidx + 1] == 0 && bisho.x < 18) {
						bisho.state = STATE_WRIGHT;
					}
					break;
				case 3:
					if (map_buffer [mapidx - 7] == 0 && bisho.y > 0) {
						bisho.state = STATE_WUP;
					}
					break;
				case 4:
					if (map_buffer [mapidx + 7] == 0 && bisho.y < 18) {
						bisho.state = STATE_WDOWN;
					}
			}
		} else {
			switch (bisho.state) {
				case STATE_WLEFT:
					bisho.x --;
					break;
				case STATE_WRIGHT:
					bisho.x ++;
					break;
				case STATE_WUP:
					bisho.y --;
					break;
				case STATE_WDOWN:	
					bisho.y ++;
					break;
			}
			
			bisho.ct ++;
			if (bisho.ct == 3)
				bisho.state = STATE_IDLE;
		}
		
		bisho.paso = !bisho.paso;	// As parece que se estn haciendo pip tol rato
	}
}

// Hacen falta a partir de aqu, y es ms seguro que queden por atrs.
// Qu me gusta el C, que te permite ser todo lo guarro que quieras!
#include "tilprites.h"

void put_3x3tilprite(unsigned char x, unsigned char y, unsigned char id) {
	int ct;

	// ct = id * 18;		// 18 bytes cada "tilprite"
	// Fijaos: id * 18 = id * 16 + id * 2; por lo tanto:

	ct = (id << 4) + (id << 1); // id * 18;

	// Y esto va mucho ms rpido :)

	sp_PrintAtInv (y	, x    , tilprites[ct ++], tilprites[ct ++]);
	sp_PrintAtInv (y	, x + 1, tilprites[ct ++], tilprites[ct ++]);
	sp_PrintAtInv (y	, x + 2, tilprites[ct ++], tilprites[ct ++]);
	
	sp_PrintAtInv (y + 1, x    , tilprites[ct ++], tilprites[ct ++]);
	sp_PrintAtInv (y + 1, x + 1, tilprites[ct ++], tilprites[ct ++]);
	sp_PrintAtInv (y + 1, x + 2, tilprites[ct ++], tilprites[ct ++]);
	
	sp_PrintAtInv (y + 2, x    , tilprites[ct ++], tilprites[ct ++]);
	sp_PrintAtInv (y + 2, x + 1, tilprites[ct ++], tilprites[ct ++]);
	sp_PrintAtInv (y + 2, x + 2, tilprites[ct ++], tilprites[ct   ]);
	
	// Bucle desenrollao marca ACME.
}

void put_2x2tilprite (unsigned char x, unsigned char y, unsigned char id) {
	unsigned char ct;
	
	ct = id << 3;	// id * 8;
	
	sp_PrintAtInv (y	, x    , minitilprites [ct ++], minitilprites [ct ++]);
	sp_PrintAtInv (y	, x + 1, minitilprites [ct ++], minitilprites [ct ++]);
	sp_PrintAtInv (y + 1, x    , minitilprites [ct ++], minitilprites [ct ++]);
	sp_PrintAtInv (y + 1, x + 1, minitilprites [ct ++], minitilprites [ct	]);
}

void draw_marcador () {
	put_2x2tilprite ( 2, 22, nanako.o1 - 1);
	put_2x2tilprite ( 5, 22, nanako.o2 - 1);
	put_2x2tilprite ( 8, 22, nanako.o3 - 1);
	put_2x2tilprite (11, 22, nanako.o4 - 1);
}

void draw_lives () {
	sp_PrintAtInv (23, 18, 71, 246);						// De pega :-P
	sp_PrintAtInv (23, 19, 71, 246 + nanako.lives);
}

void clear_persistencias () {
	// Limpia el buffer de persistencias
	unsigned char i;
	for (i = 0; i < NUM_PERSISTENCIAS; i ++)
		persistencias [i].pant = 101;						// Fuera de rango. Sucio, feo, pero frkimente eficiente.
}

void add_persistencia (unsigned char pant, unsigned char x, unsigned char y) {
	// Aade una persistencia al mapa.	
	unsigned char i;
	for (i = 0; i < NUM_PERSISTENCIAS; i ++) {
		if (persistencias [i].pant == 101) {
			persistencias [i].pant = pant;
			persistencias [i].x = x;
			persistencias [i].y = y;
			break;	
		}
	}
}

void draw_screen (char pant) {
	// Dibuja la pantalla que recibe como parmetro.
	
	unsigned char x = 1, y = 1;
	unsigned char i, tile, tilel2, beh;
	unsigned int index, indexmasi, ct;
	
	// Calculamos el offset real de la pantalla que queremos dibujar.
	index = ((int)pant) * 49;

	for (i = 0; i < 49; i ++) {
		indexmasi = index + i;
		tile = map_buffer_r [i] = map_data [indexmasi];
		beh = map_buffer [i] = behaviour [tile - 1];		// Como te dejes un tile a 0 esto EXPLOTA.
		
		ct = (tile << 4) + (tile << 1); // tile * 18
		
		sp_PrintAtInv (y	, x    , x == 1 ? tilprites [ct] : (beh == 1 ? tilprites [ct] : (map_buffer [i - 8] == 1 ? 1 : tilprites [ct])), tilprites [ct + 1]); ct += 2;
		sp_PrintAtInv (y	, x + 1, y == 1 ? tilprites [ct] : (beh == 1 ? tilprites [ct] : (map_buffer [i - 7] == 1 ? 1 : tilprites [ct])), tilprites [ct + 1]); ct += 2;
		sp_PrintAtInv (y	, x + 2, y == 1 ? tilprites [ct] : (beh == 1 ? tilprites [ct] : (map_buffer [i - 7] == 1 ? 1 : tilprites [ct])), tilprites [ct + 1]); ct += 2;
		
		sp_PrintAtInv (y + 1, x    , x == 1 ? tilprites [ct] : (beh == 1 ? tilprites [ct] : (map_buffer [i - 1] == 1 ? 1 : tilprites [ct])), tilprites [ct + 1]); ct += 2;
		sp_PrintAtInv (y + 1, x + 1, tilprites [ct ++], tilprites [ct ++]);
		sp_PrintAtInv (y + 1, x + 2, tilprites [ct ++], tilprites [ct ++]);
		
		sp_PrintAtInv (y + 2, x    , x == 1 ? tilprites [ct] : (beh == 1 ? tilprites [ct] : (map_buffer [i - 1] == 1 ? 1 : tilprites [ct])), tilprites[ct + 1]); ct += 2;
		sp_PrintAtInv (y + 2, x + 1, tilprites[ct ++], tilprites[ct ++]);
		sp_PrintAtInv (y + 2, x + 2, tilprites[ct ++], tilprites[ct   ]);
		
		if (!beh)
			if ((rand () & 7) == 3) 
				sp_PrintAt (y + (rand () % 3), x + (rand () % 3), 7, 245);
		
		x += 3; 
		if (x == 22) {
			x = 1;
			y += 3;
		}
	}
	
	// Control de persistencias: rboles cortados o verjas rotas:

	for (i = 0; i < NUM_PERSISTENCIAS; i ++)
		if (persistencias [i].pant == pant) {
			beh = 7 * (persistencias [i].y / 3) + (persistencias [i].x / 3);
			map_buffer [beh] = 0;
			map_buffer_r [beh] = 1;
			put_3x3tilprite (1 + persistencias [i].x, 1 + persistencias [i].y, 1);
		}
	
	// Pintar objeto, si lo hay:
	
	if (objetos_g [pant]) {
		put_3x3tilprite (10, 10, objetos_t [objetos_g [pant]]);
		map_buffer [24] = 3;	
	}
	
	// Al azar, una de cada cuatro pantallas tiene un bisho.
	// Es posible que cambie esto en el futuro para que el bisho "aparezca"
	// en la pantalla estando ya en ella, como en el saimazoom.
	
	tiene_bisho = 0;
	
	if (pant != 95)
		if ( (rand () & 3) <= 1 ) {
			tiene_bisho = 1;
			do {
				bisho.x = 1 + (rand () % 5);
				bisho.y = 1 + (rand () % 5);
			} while (map_buffer [7 * bisho.y + bisho.x] != 0);
			
			bisho.cx = bisho.x = 3 * bisho.x;
			bisho.cy = bisho.y = 3 * bisho.y;
			
			bisho.frame = 61 + 2 * (rand () % 5);
			bisho.ct = 0;
			
			rectangulo.row_coord = 1 + bisho.y;
			rectangulo.col_coord = 1 + bisho.x;
			sp_GetTiles (&rectangulo, buffer_bisho);
			
			bisho.state = STATE_IDLE;
		}
}

char espera_activa (int espera) {
	// Esta funcin espera un rato o hasta que se pulse una tecla.
	// Si se pulsa una tecla, devuelve 0
	
	// Esta funcin slo funciona en Spectrum.
	// en CPC no hay una interrupcin cada 20ms, asn que esto no
	// sirve "pa n".
	
	char res = 1;
	int i;
	
	for (i = 0; i < espera && res; i ++) {
		#asm
			halt
		#endasm
		if (sp_GetKey ()) 
			res = 0;
	}
	
	return res;
}

void final (void) { 
	unsigned char i = 0, j;
	unsigned char aux_tiles;
	
	allpurposepuntero = full_font;
	for (aux_tiles = 0; aux_tiles < 64; aux_tiles++) {
		sp_TileArray ((unsigned char)aux_tiles, allpurposepuntero);
		allpurposepuntero += 8;
	} 

	fade_out ();
	blackout_everything ();
	
	sp_UpdateNow ();
	unpack_RAM3 (S_FINAL);
	
	allpurposepuntero = (unsigned char *) 23264;
	for (i = 0; i < 32; i ++) {
		*allpurposepuntero = 71;
		allpurposepuntero ++;
	}
	
	wyz_play_music (0);
	
	do {		
		if (menzae [i] == 0xff) 
			i = 0;
			
		sp_PrintAtInv (23, 31, 0, menzae [i] - 32);
		sp_UpdateNow ();
		i ++;
		
		for (j = 0; j < 8; j ++) {
			#asm
				; Scrollea un pixel la linea de abajo
				; por Benway.
			
					ld hl, 22527  ; Empezamos en la ltima lnea
					ld c, 8 	  ; 8 pxeles de alto
					halt		  ; Sincronizamos con el retrazo
				.ending_scroller_buc_2
					ld b,32 	  ; 32 bytes de ancho
				.ending_scroller_buc_1
					rl (hl) 	  ; Rotamos el byte que corresponda
					dec hl		  ; Y pasamos al siguiente
					djnz ending_scroller_buc_1
					dec h		  ; Para no pasarnos de caracter, tenemos que restar (255 - 32)
					ld a,l		  ; Y ahora sumamos el 32 que no restamos antes
					add a,32	  ; Pues eso
					ld l,a		  ; Y lo devolvemos a L
					dec c
					jr nz, ending_scroller_buc_2
			#endasm
		}
		j = (joyfunc) (&keys);
	} while (j & sp_FIRE);
	
	wyz_stop_sound ();
}

void menu () {
	unsigned char ct; 
	unsigned char i;
	unsigned char terminado = 0, terminado2 = 0;
	unsigned char chg_sch = 1;
	unsigned char aux_tiles;
	int counter;
	
	wyz_play_music (1);
	
	allpurposepuntero = menu_tiles;
	for (aux_tiles = 0; aux_tiles < 17; aux_tiles++) {
		sp_TileArray ((unsigned char)aux_tiles, allpurposepuntero);
		allpurposepuntero += 8;
	}
	
	joyfunc = sp_JoyKeyboard;
	
	while (!terminado2) {
		
		if (!aftergame) {
			
			blackout_everything ();
			unpack_RAM3 (S_MOJON_TWINS);
			
			if (espera_activa (200)) {
				fade_out ();
				unpack_RAM3 (S_UBHRES);
				
				if (espera_activa (200)) {
					fade_out ();
					unpack_RAM3 (S_COMIC_1);
					
					if (espera_activa (300)) {
						unpack_RAM3 (S_COMIC_2);
						
						if (espera_activa (300)) {
							unpack_RAM3 (S_COMIC_3);
							
							espera_activa (300);
						}
					}
				}	 
			}
			
			fade_out ();
		}
		
		aftergame = 0;
		counter = 0;
		terminado = 0;
	
		sp_ClearRect(sp_ClipStruct, 0, 0, sp_CR_TILES);
		sp_UpdateNow();
		
		blackout_everything ();
		unpack_RAM3 (S_MENU);
		
		sp_PrintAtInv (18, 10, 0, 0);
		sp_PrintAtInv (18, 21, 0, 0);	 
		chg_sch = 1;
		
		while (!terminado) {
			ct = !ct;
			
			// **********************************************************
			// Cambios
			// **********************************************************
			
			if (kempston_is_attached) {
				i = sp_JoyKeyboard (&keys) & sp_JoyKempston ();
			} else {
				i = sp_JoyKeyboard (&keys);
			}
				
			if ( (i & sp_LEFT) == 0 && joykeyboard == 0 ) {
				joykeyboard = 1;
				chg_sch = 1;
			}
			
			if ( (i & sp_RIGHT) == 0 && joykeyboard == 1 ) {
				joykeyboard = 0;
				chg_sch = 1;
			}
			
			if ( (i & sp_FIRE) == 0) {
				terminado = 1;
				terminado2 = 1;
			}
			
			if (chg_sch) {
				if (joykeyboard) {
					joyfunc = sp_JoyKempston;
					sp_PrintAtInv (18, 11, 70, 15);
					for (i = 0; i < 8; i ++)
						sp_PrintAtInv (18, 12 + i, 71, i);
					sp_PrintAtInv (18, 20, 66, 13); 			
				} else {
					joyfunc = sp_JoyKeyboard;
					sp_PrintAtInv (18, 11, 66, 14);
					sp_PrintAtInv (18, 12, 71, 7);
					sp_PrintAtInv (18, 13, 71, 8);
					sp_PrintAtInv (18, 14, 71, 2);
					sp_PrintAtInv (18, 15, 71, 9);
					sp_PrintAtInv (18, 16, 71, 1);
					sp_PrintAtInv (18, 17, 71, 10);
					sp_PrintAtInv (18, 18, 71, 11);
					sp_PrintAtInv (18, 19, 71, 12);
					sp_PrintAtInv (18, 20, 70, 16); 
				}
			}
			
			chg_sch = 0;
			
			sp_UpdateNow ();
			
			// **********************************************************
			// Ejcrol de toda la pantalla que quede petnido.
			// **********************************************************
			
			#asm
				halt
			#endasm
			
			if (ct == 0) {
				for (i = 0; i < 5; i ++) {
					asm_int = i;
					#asm
						call escrolleft
					#endasm
				}
				
				asm_int = 15;	
				#asm
					call escrolleft
				#endasm
				
				asm_int = 16;
				#asm
					call escrolleft
				#endasm
			}
			
			for (i = 19; i < 23; i ++) {
				asm_int = i;
				#asm
					call escrolleft
				#endasm 
			}
			
			counter ++;
			if (counter == 750)
				terminado = 1;
		}
	}
	
	wyz_stop_sound ();
}

void main (void)
{
	unsigned char j, x, y;
	int aux_tiles;
	unsigned char i;
	char idx;
	unsigned char *wyz_music_flag;

	unsigned char pant, npant;
	unsigned char playthegame;
	char dif;
	
	unsigned char flag1 = 0, flag2 = 0;
	unsigned char aux, changing;
	int key_g;
	int key_c; // ** DELETE ME **
	
	unsigned char win;
	
	// By Jon Needle:
	
	#asm
		halt
		in	a, (31)
		inc a
		ld	(_kempston_is_attached), a
	#endasm
	
	/* Substitute BASICs ISR for this thingo: */
	#asm
		di
	#endasm

	sp_InitIM2(0xf1f1); 					// Does nothing :)
	sp_CreateGenericISR(0xf1f1);
	sp_RegisterHook(255, ISR);			// Registramos el hook - Gracias Utopian!
	
	#asm
		ei
	#endasm

	#asm
		; Chequea si son 128k y lo pone en la variable is128k
		; Code by BlackHole
		LD		HL,$F1FF
		LD		(HL),1
		LD		A,$01
		LD		BC,7FFDh
		OUT 	(C),A
		LD		(HL),0
		LD		A,($5B5C)
		AND 	$F8
		LD		BC,$7FFD
		OUT 	(C),A
		LD		A,(HL)
		LD		(_is128k),A
	#endasm
	
	/* Initialization stuff */

	sp_Initialize (0, 0);
	sp_Border (BLACK);
	sp_AddMemory(0, 50, 14, AD_FREE);		// Allocate for 50 blocks of memory (tight!)
	ps.flags  = sp_PSS_INVALIDATE;
	ps.bounds = sp_ClipStruct;

	/* Clip structure -- define it as small as possible! */

	spritesClipValues.row_coord = 1;
	spritesClipValues.col_coord = 1;
	spritesClipValues.height = 18;
	spritesClipValues.width = 30;
	spritesClip = &spritesClipValues;
	
	keys.up    = sp_LookupKey ('q');
	keys.down  = sp_LookupKey ('a');
	keys.left  = sp_LookupKey ('o');
	keys.right = sp_LookupKey ('p');
	keys.fire  = sp_LookupKey (' ');
		
	key_g = sp_LookupKey ('g');
	key_c = sp_LookupKey ('c'); // ** DELETE ME **
	
	// Empezamos!
	
	fade_out ();
		
	while (1) {
		
		// Men (define sus propios tiles,
		
		menu ();
		
		// As que ahora tenemos que redefinir los del juego:
		
		allpurposepuntero = gfx_tiles;
		for (aux_tiles = 0; aux_tiles < 256; aux_tiles++) {
			sp_TileArray ((unsigned char)aux_tiles, allpurposepuntero);
			allpurposepuntero += 8;
		}

		rectangulo.height = rectangulo.width = 3;
		npant = pant = 95;		// Un pon
		flag1 = 0;
		
		nanako.cx = nanako.x = 9;
		nanako.cy = nanako.y = 15;
		nanako.state = STATE_IDLE;
		nanako.ct = 0;
		nanako.lives = 5;
		nanako.frame = 51;
		nanako.paso = 0;
		nanako.o1 = nanako.o2 = nanako.o3 = nanako.o4 = 5;
		changing = 0;
		win = 0;
		
		for (i = 0; i < 100; i ++)
			objetos_g [i] = objetos [i];
				
		// Bonito
		sp_UpdateNow();
		blackout_everything ();
		unpack_RAM3 (S_MARCO);
		
		draw_screen (pant);
		
		// get bk;
		rectangulo.row_coord = 1 + nanako.y;
		rectangulo.col_coord = 1 + nanako.x;
		sp_GetTiles (&rectangulo, buffer_nanako);
		
		draw_marcador ();
		draw_lives ();
		
		clear_persistencias ();
		
		wyz_play_music (2);
		
		while (!flag1) {
			
			// ***************************************************************
			// Cambio de pantalla:
			// ***************************************************************
			
			i = (joyfunc) (&keys);
		
			if ((i & sp_LEFT) == 0 && nanako.x == 0) {
				nanako.x = 18;
				npant --;
				nanako.frame = 53;
			}
			
			if ((i & sp_RIGHT) == 0 && nanako.x == 18) {
				nanako.x = 0;
				npant ++;
				nanako.frame = 51;
			}
			
			if ((i & sp_UP) == 0 && nanako.y == 0) {
				nanako.y = 18;
				npant -= 10;
				nanako.frame = 57;
			}
				
			if ((i & sp_DOWN) == 0 && nanako.y == 18) {
				nanako.y = 0;
				npant += 10;
				nanako.frame = 55;
			}
				
			if (pant != npant) {
				pant = npant;
				draw_screen (pant);
				// get bk;
				rectangulo.height = rectangulo.width = 3;
				rectangulo.row_coord = 1 + nanako.y;
				rectangulo.col_coord = 1 + nanako.x;
				sp_GetTiles (&rectangulo, buffer_nanako);
				
				nanako.cx = nanako.x;
				nanako.cy = nanako.y;
			}
			
			// ***************************************************************
			// Cambio de objeto:
			// ***************************************************************
			
			if (objetos_g [pant]) {
				if (
						( (i & sp_LEFT) == 0 && nanako.x == 12 && nanako.y == 9 ) ||
						( (i & sp_RIGHT) == 0 && nanako.x == 6 && nanako.y == 9 ) ||
						( (i & sp_UP) == 0 && nanako.x == 9 && nanako.y == 12 ) ||
						( (i & sp_DOWN) == 0 && nanako.x == 9 && nanako.y == 6 )
				) {
					if (!changing) {
						changing = 1;		// Para que haya que depulsar la tecla
						
						// Mira lo que hacemos:
						// AUX = OBJETO
						// OBJETO = O4
						// O4 = O3
						// O3 = O2
						// O2 = O1
						// O1 = AUX
						
						aux = objetos_g [pant];
						
						// Sonido
						if (aux == 4)
							wyz_play_sound (0, 1);
						else
							wyz_play_sound (1, 1);
						
						objetos_g [pant] = nanako.o4;
						nanako.o4 = nanako.o3;
						nanako.o3 = nanako.o2;
						nanako.o2 = nanako.o1;
						nanako.o1 = aux;
						
						put_3x3tilprite (10, 10, objetos_t [objetos_g [pant]]);
						draw_marcador ();
					}
				} else {
					changing = 0;
				}			
			}
			
			// ***************************************************************
			// Blit
			// ***************************************************************
			
			sp_UpdateNow ();	
			
			// ***************************************************************
			// Mover mierda
			// ***************************************************************
			
			mueve ();
			mueve_bicharracos ();
			
			// ***************************************************************
			// Uso de objetos en objetos fijos.
			// ***************************************************************
			
			if (nanako.colliding && (i & sp_FIRE) == 0) {
				aux = 0;
				
				// Reja <-> Cortafro
				if (nanako.colliding == 40) {
					if (nanako.o1 == 2) {
						aux = 1;
						nanako.o1 = 5;
					} else if (nanako.o2 == 2) {
						aux = 1;
						nanako.o2 = 5;
					} else if (nanako.o3 == 2) {
						aux = 1;
						nanako.o3 = 5;
					} else if (nanako.o4 == 2) {
						aux = 1;
						nanako.o4 = 5;
					}
				}
				
				// rboles <-> Jacha
				if (nanako.colliding >= 12 && nanako.colliding <= 15) {
					if (nanako.o1 == 3) {
						aux = 2;
						nanako.o1 = 5;
					} else if (nanako.o2 == 3) {
						aux = 2;
						nanako.o2 = 5;
					} else if (nanako.o3 == 3) {
						aux = 2;
						nanako.o3 = 5;
					} else if (nanako.o4 == 3) {
						aux = 2;
						nanako.o4 = 5;
					}
				}
				
				// fer:
				if (aux != 0) {
					// Nos cargamos el tile que sea:
					
					if (aux == 1)
						wyz_play_sound (2, 1);
					else
						wyz_play_sound (3, 1);
					
					switch (nanako.facing) {
						case FACING_LEFT:
							x = nanako.x - 3;
							y = nanako.y; 
							break;
						case FACING_RIGHT:
							x = nanako.x + 3;
							y = nanako.y;
							break;
						case FACING_UP:
							x = nanako.x;
							y = nanako.y - 3;
							break;
						case FACING_DOWN:
							x = nanako.x;
							y = nanako.y + 3;
					}
					
					j = 7 * (y / 3) + (x / 3);
					map_buffer [j] = 0;
					map_buffer_r [j] = 1;
					
					put_3x3tilprite (1 + x, 1 + y, 1);
					draw_marcador ();
					add_persistencia (pant, x, y);
				}
			}
			
			// ***************************************************************
			// Hacer comprobaciones:
			// ***************************************************************
			
			// Vemos si te das un morrazo contra un bisho
			
			if (tiene_bisho) {
				if (bisho.x == nanako.x && bisho.y == nanako.y) {
					aux = 0;
					if (nanako.o1 == 1) {
						aux = 1;
						nanako.o1 = 5;
					} else if (nanako.o2 == 1) {
						aux = 1;
						nanako.o2 = 5;
					} else if (nanako.o3 == 1) {
						aux = 1;
						nanako.o3 = 5;
					} else if (nanako.o4 == 1) {
						aux = 1;
						nanako.o4 = 5;
					}
					
					if (aux) {
						wyz_play_sound (4, 1);
						draw_marcador ();	
					} else {
						wyz_play_sound (5, 1);
						nanako.lives --;
						if (nanako.lives < 0) {
							flag1 = 1;
						} else {
							draw_lives ();
						}
					}
					
					rectangulo.row_coord = 1 + bisho.cy;
					rectangulo.col_coord = 1 + bisho.cx;
					sp_PutTiles (&rectangulo, buffer_bisho);
					sp_Invalidate (&rectangulo, &rectangulo);
					
					tiene_bisho = 0;
				}
			}
			
			// Vemos si nos terminamos el juego. La condicin es estar en la
			// pantalla inicial (nmero 95) y que los cuatro objetos sean el 4
			// (o sea, el tesoro).
			
			if (pant == 95)
				if (nanako.o1 == 4)
					if (nanako.o2 == 4)
						if (nanako.o3 == 4)
							if (nanako.o4 == 4)  {
								win = 1;
								flag1 = 1;
							}
							
			// Vemos si se pulsa "abortar"
			
			if (sp_KeyPressed (key_g)) 
				flag1 = 1;
				
			if (sp_KeyPressed (key_c)) {	// ** DELETE ME **
				nanako.o1 = 4;
				nanako.o2 = 4;
				nanako.o4 = 4;
				nanako.o3 = 4;
				draw_marcador ();
			}
			
			// ***************************************************************
			// Dibujar tilprites:
			// ***************************************************************
			
			// Restore bk
			rectangulo.row_coord = 1 + nanako.cy;
			rectangulo.col_coord = 1 + nanako.cx;
			sp_PutTiles (&rectangulo, buffer_nanako);
			sp_Invalidate (&rectangulo, &rectangulo);
			
			if (tiene_bisho) {
				// Restore bk
				rectangulo.row_coord = 1 + bisho.cy;
				rectangulo.col_coord = 1 + bisho.cx;
				sp_PutTiles (&rectangulo, buffer_bisho);
				sp_Invalidate (&rectangulo, &rectangulo);
			}				
						
			// Get bk
			rectangulo.row_coord = 1 + nanako.y;
			rectangulo.col_coord = 1 + nanako.x;
			sp_GetTiles (&rectangulo, buffer_nanako);
			
			if (tiene_bisho) {
				// Get bk
				rectangulo.row_coord = 1 + bisho.y;
				rectangulo.col_coord = 1 + bisho.x;
				sp_GetTiles (&rectangulo, buffer_bisho);
			}
			
			// Draw sprite
			put_3x3tilprite (1 + nanako.x, 1 + nanako.y, nanako.frame + nanako.paso);

			nanako.cx = nanako.x;
			nanako.cy = nanako.y;
			
			if (tiene_bisho) {
				// Draw sprite
				put_3x3tilprite (1 + bisho.x, 1 + bisho.y, bisho.frame + bisho.paso);
	
				bisho.cx = bisho.x;
				bisho.cy = bisho.y;
			}
		}
		
		wyz_stop_sound ();
		
		sp_WaitForNoKey ();
		aftergame = 1;
		fade_out ();
		
		if (nanako.lives < 0) {
			fade_out ();
			
			wyz_play_music (3);
			
			unpack_RAM3 (S_GAME_OVER);
			
			espera_activa (200);
			wyz_stop_sound ();			  
			
			sp_WaitForKey ();
			sp_WaitForNoKey ();
			
			fade_out ();
		}
		
		if (win) {
			// Presentar la secuencia final... A ver qu hago.	
			// Pantalla esttica, scroller y msica?
			// Va a ser que s.
			
			final ();
		}
	}
	
}	

#include "tiles.h"
#include "map.h"

/*
	The passion of Lovers - Bauhaus
	===============================
	
		She had nut painted arms
		That were hers to keep
		And in her fear
		She sought cracked pleasures
		The passion of lovers is for death said she
		Licked her lips
		And turned to feather
		
		And as I watched from underneath
		I came aware of all that she keep
		The little foxes so safe and sound
		They were not dead
		Theyd gone to ground
		
		The passion of lovers is for death said she
		The passion of lovers is for death
		The passion of lovers is for death said she
		The passion of lovers is for death
		
		She breaks her hear
		Just a little too much
		And her jokes attract the lucky bad type
		As she dips and wails
		And slips her banshee smile
		She gets the better of the bigger to the letter
		
		The passion of lovers is for death said she
		The passion of lovers is for death
		The passion of lovers is for death said she
		The passion of lovers is for death
		The passion of lovers is for death said she
		The passion of lovers is for death
		The passion of lovers is for death said she

*/
